#----------------------------------------------------------------
# Copyright (c) 2004 Benjamin Crowell, all rights reserved.
#
# This software is available under version 2 of the GPL license.
# The software is copyrighted, and you must agree to the
# license in order to have permission to copy it. The full
# text of the license is given in the file titled Copying.
#
#----------------------------------------------------------------

use strict;

package NontonalActivity;

our @ISA = 'Activity';

=head1 NontonalActivity class

This subclass of Activity is an abstract class, which is subclassed to make more specific types of activities.

=cut

=head2 new

NontonalActivity->new(...,FSM=>'my_fsm',FSM_FILE=>['/where/it/is','my_fsm.logic'])

where ... is stuff for the Activity class.

=cut

sub new {
  my $class = shift;
  my %args = (
    FSM=>'NontonalActivity',
    FSM_FILE=>['/usr/local/share/clamor/logic','NontonalActivity.logic'],
		@_,
	);
  my $self = Activity->new(%args);
  bless($self,$class); # rebless into subclass
  $self->{FSM} = FiniteStateMachine->new($args{FSM},$args{FSM_FILE});
  if (! ref $self->{FSM}) {die $self->{FSM}}
  return $self;
}



1;
