use strict;

use CPAN;

my @modules = (
              "Audio::Data",
              "Audio::Play",
              "Clone",
#              "Ogg::Vorbis",
);
	# modules with ! in front of the names are ignored

print <<INFO;
Clamor installation

This installer will download and install some open-source software
from cpan.org that is required for Clamor to run.

The following modules will be required:
INFO

foreach my $mod(@modules) {
  print "      $mod\n" unless $mod =~ m/^!/;
}

print <<INFO;
     Modules that are already installed will not be touched.

If you continue with installation, you will probably get lots and lots
of output on the screen. If everything is working as it should, you can
ignore all of it!

Do you want to continue with installation?
Enter y to continue, or n to quit.
INFO


my $response = <STDIN>;
$response = lc($response);
exit unless $response =~ m/^y/;

foreach my $mod(@modules) {
  if (!($mod=~m/^!/)) {
    print "----------------------------\nInstalling $mod\n";
    install $mod;
  }
}

print "\n\n---------------------\nDone.\n";
