#!/usr/bin/perl

use strict;

use Audio::Data;
use Audio::Play;

use Analyze;

our $duration = 10.;

my $server = Audio::Play->new;

my $f = 523.251; # Hz; C an octave above middle C
my $sound = Audio::Data->new(rate=>44100.);
$sound->silence($duration);
for (my $j=1; $j<=10; $j++) {
  my $partial = make_sine($f*$j);
  $sound = $sound + $partial;
}
$server->play($sound);

open(FH,">test_tone_72.au");
binmode FH;
$sound->Save(*FH);
close FH;

sub make_sine {
  my $freq = shift;
  my $sound = Audio::Data->new(rate=>44100.);
  $sound->tone($freq,$duration,0.09);
  return $sound;
}
