#!/usr/bin/perl

use strict;

use FiniteStateMachine;

my $fsm = FiniteStateMachine->new('note_tonic',['/usr/local/share/clamor/logic','note_tonic.logic']);

if (! ref $fsm) {die $fsm}

$fsm->register(
  {
    note=>sub{print "consider yourself notified\n"}
  }
);

for (;;) {
  print "state=".$fsm->state."\n";
  last if ($fsm->state() eq 'end');
  my $poss = $fsm->list_transitions;
  print "possibilities: ".(join(' ',keys %$poss))."\n";
  my $choice = <STDIN>;
  chomp $choice;
  if (exists $poss->{$choice}) {
    $fsm->transition($choice);
  }
}


